#include "RDriver.h"
#include "RDriverInt.h"

#define PPbanner \
"=======================================================================\n" \
"PlayerPRO Driver v4.5.4 - Portable version - Programmed by A.ROSSET '97\n" \
"=======================================================================\n" \
"            DirectSound Version for Windows 95 or Windows NT           \n" \
"\n" \
"          Compiled on PowerMacintosh using CodeWarrior IDE x86         \n" \
"=======================================================================\n" \
"       This program is FREEWARE - Read README.TXT for more info\n" \
"\n" \
"      E-Mail : rosset@dial.eunet.ch    Phone : (+41 79) 203 74 62\n"\
"=======================================================================\n" \
" Current settings: 44Khz-16bits-Stereo-MicroDelay 35ms-Interpolation \n" \
"=======================================================================\n"

void debugger( Ptr a)
{
	printf( a);
	getchar();
}

int main( int argc, char *argv[])
{
	MADDriverSettings	init;
  	long				fT, cT;
  	char 				type[ 5];
  	
  	puts( PPbanner);
  	
  	if (argc < 2)
  	{
		puts("Usage: PP MyMAD.mad \n");
		getchar();
		exit(-1);
	}
  	
	////////
	
	init.numChn				= 4;
	init.outPutBits 		= 16;
	init.outPutRate			= 44100L<<16L;
	init.outPutMode			= DeluxeStereoOutPut;
	init.driverMode			= DirectSound95NT;
	init.antiAliasing		= false;
	init.repeatMusic		= false;
	init.Interpolation		= true;
	init.MicroDelay			= true;
	init.MicroDelaySize 	= 35;
	init.surround		 	= false;
	init.sysMemory			= false;
	init.Reverb				= false;
	init.ReverbSize			= 45;
	init.ReverbStrength		= 70;
	init.TickRemover		= false;
	
	// MS-DOS version DOESNT SUPPORT PLUGS !!! ONLY MADH files
	
	if( MADInitLibrary( 0L, 0)) {debugger( "ERR MADInitLibrary\n");exit(0);}
	if( MADCreateDriver( &init)) {debugger( "ERR MADCreateDriver\n");exit(0);}
	
	if( MADMusicIdentifyCString( type, argv[ 1]))  {debugger( "ERR MADMusicIdentifyCString\n"); exit(0);}
	if( MADLoadMusicFileCString( type, argv[ 1])) {debugger( "ERR MADLoadMusicFile\n"); exit(0);}
	
	MADStartDriver();
	
	MADPlayMusic();
	
	MADGetMusicStatus( &fT, &cT);
	
	printf("\n\nMusic length: %i s", fT);
	printf("\nPress Return to exit\n");
	
	getchar();
	
	MADStopMusic();
	MADStopDriver();
	
	MADDisposeDriver();
	MADDisposeLibrary();
	
	exit(0);
}